package com.shigongli.common;

import com.shigongli.config.ScreenShotConfig;
import org.openqa.selenium.OutputType;
import org.openqa.selenium.TakesScreenshot;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.chrome.ChromeDriver;
import org.openqa.selenium.chrome.ChromeOptions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.io.File;
import java.util.concurrent.TimeUnit;

@Component
public class ScreenShotUtil {
    @Autowired
    OSSUtils ossUtils;

    @Autowired
    ScreenShotConfig config;

    public String shot(String url) throws Exception {
        //驱动地址
        System.setProperty("webdriver.chrome.driver", config.getDriver());

        WebDriver webDriver = null;
        ChromeOptions options=new ChromeOptions();
        //设置 chrome 的无头模式
        options.addArguments("--headless");
        options.addArguments("--disable-gpu");
        options.addArguments("--no-sandbox");
        options.addArguments("--disable-dev-shm-usage");
        options.addArguments("--start-maximized");
        options.addArguments("--lang=zh");
        options.addArguments(String.format("--window-size=%s,%s", config.getWidth(), config.getHeight()));
        //启动一个 chrome 实例
        webDriver = new ChromeDriver(options);

        //访问网址
        webDriver.get(url);
//        Thread.sleep(config.getWait());
        webDriver.manage().timeouts().implicitlyWait(config.getWait(), TimeUnit.MILLISECONDS);

        //截取全屏
        File f  = ((TakesScreenshot)webDriver).getScreenshotAs(OutputType.FILE);

        // 存入 oss
        String imageUrl = ossUtils.putObject(f);

        //退出
        webDriver.quit();

        return imageUrl;
    }
}
