package com.shigongli.common;

import cn.binarywang.wx.miniapp.api.WxMaService;
import cn.binarywang.wx.miniapp.api.impl.WxMaServiceImpl;
import cn.binarywang.wx.miniapp.config.impl.WxMaDefaultConfigImpl;
import com.shigongli.config.WeixinConfig;
import lombok.Data;
import lombok.Getter;
import me.chanjar.weixin.mp.api.WxMpService;
import me.chanjar.weixin.mp.api.impl.WxMpServiceImpl;
import me.chanjar.weixin.mp.config.impl.WxMpDefaultConfigImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Getter
@Component
public class WxUtils {
    private WxMaService maService;
    private WxMpService mpService;

    @Autowired
    public WxUtils(WeixinConfig config) {
        initMaService(config);
        initMpService(config);
    }

    private void initMaService(WeixinConfig config) {
        WxMaDefaultConfigImpl conf = new WxMaDefaultConfigImpl();
        conf.setAppid(config.getMa().getAppid());
        conf.setSecret(config.getMa().getSecret());
        conf.setToken(config.getMa().getToken());
        conf.setAesKey(config.getMa().getAesKey());
        conf.setMsgDataFormat(config.getMa().getMsgDataFormat());

        maService = new WxMaServiceImpl();
        maService.setWxMaConfig(conf);
    }

    private void initMpService(WeixinConfig config) {
        WxMpDefaultConfigImpl conf = new WxMpDefaultConfigImpl();
        conf.setAppId(config.getMp().getAppid());
        conf.setSecret(config.getMp().getSecret());
        conf.setToken(config.getMp().getToken());
        conf.setAesKey(config.getMp().getAesKey());

        mpService = new WxMpServiceImpl();
        mpService.setWxMpConfigStorage(conf);
    }
}
