package com.shigongli.config;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.boot.context.properties.NestedConfigurationProperty;
import org.springframework.stereotype.Component;

@Data
@Component
@ConfigurationProperties(prefix = "aliyun")
public class AliyunConfig {
    private String accessKeyId;
    private String accessKeySecret;

    @NestedConfigurationProperty
    private Oss oss = new Oss();

    @NestedConfigurationProperty
    private Sms sms = new Sms();

    @Data
    public  static class Oss {
        private String endpoint;
        private String bucketName;
        private String bucketURL;
    }

    @Data
    public static class Sms {
        @NestedConfigurationProperty
        private Captcha captcha = new Captcha();
    }

    @Data
    public static class Captcha {
        private String code;
        private String sign;
    }
}
