package com.shigongli.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.shigongli.common.BaseController;
import com.shigongli.common.OSSUtils;
import com.shigongli.common.ResponseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import com.shigongli.service.ITaMetaImageService;
import com.shigongli.entity.TaMetaImage;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;

/**
 * <p>
    * 图片素材 前端控制器
    * </p>
 *
 * @author yansen
 * @since 2020-12-11
 */

@Api(tags = "图片素材")
@RestController
@RequestMapping("/")
public class TaMetaImageController extends BaseController {

    private final Logger logger = LoggerFactory.getLogger(TaMetaImageController.class);

    @Autowired
    public ITaMetaImageService iTaMetaImageService;

    @Autowired
    OSSUtils ossUtils;


//    /**
//     * 分页查询列表
//     * @param pageNum
//     * @param pageSize
//     * @return
//     */
//    @RequestMapping(value="/taMetaImage",method= RequestMethod.GET)
//    @ApiOperation(value="列表", notes = "列表", httpMethod = "GET", response = ResponseBean.class)
//    public ResponseBean taMetaImageList(@ApiParam("页码") @RequestParam(value ="pageNum",defaultValue = "1") Integer pageNum,
//									 @ApiParam("单页数据量") @RequestParam(value ="pageSize",defaultValue = "10") Integer pageSize) throws Exception{
//
//		    IPage<TaMetaImage> pg = new Page<>(pageNum, pageSize);
//            QueryWrapper<TaMetaImage> queryWrapper = new QueryWrapper<>();
//            queryWrapper.orderByDesc("create_date");
//
//            IPage<TaMetaImage> result = iTaMetaImageService.page(pg, queryWrapper);
//            return ResponseBean.success(result);
//    }
//
    /**
     * 保存对象
     * @param taMetaImage 实体对象
     * @return
     */
    @RequestMapping(value="/mp/taMetaImage",method= RequestMethod.POST)
    @ApiOperation(value="保存", notes = "保存", httpMethod = "POST", response = ResponseBean.class)
    public ResponseBean taMetaImageAdd(@RequestParam("file") MultipartFile multipartFile) throws Exception{

        try {
            String image = ossUtils.putObject(multipartFile, "/shigongli/images/");

            TaMetaImage taMetaImage = new TaMetaImage();
            taMetaImage.setImage(image);

            iTaMetaImageService.save(taMetaImage);
            return ResponseBean.success(taMetaImage);
        } catch (IOException e) {
            return ResponseBean.error("上传图片失败: " + e.getMessage(), ResponseBean.ERROR_UNAVAILABLE);
        }

    }
//
//    /**
//     * 根据id删除对象
//     * @param id  实体ID
//     */
//    @RequestMapping(value="/taMetaImage/{id}", method= RequestMethod.DELETE)
//    @ApiOperation(value="删除", notes = "删除", httpMethod = "DELETE", response = ResponseBean.class)
//    public ResponseBean taMetaImageDelete(@ApiParam("对象ID") @PathVariable Integer id) throws Exception{
//        if(iTaMetaImageService.removeById(id)){
//            return ResponseBean.success("success");
//        }else {
//            return ResponseBean.error("删除失败, 请重试", ResponseBean.ERROR_UNAVAILABLE);
//        }
//    }
//
//    /**
//     * 修改对象
//     * @param id  实体ID
//     * @param taMetaImage 实体对象
//     * @return
//     */
//    @RequestMapping(value="/taMetaImage/{id}",method= RequestMethod.PUT)
//    @ApiOperation(value="更新", notes = "更新", httpMethod = "PUT", response = ResponseBean.class)
//    public ResponseBean taMetaImageUpdate(@ApiParam("对象ID") @PathVariable Integer id,
//                                        @ApiParam("更新内容") @RequestBody TaMetaImage taMetaImage) throws Exception{
//
//        if (iTaMetaImageService.updateById(taMetaImage)){
//            return ResponseBean.success(iTaMetaImageService.getById(id));
//        }else {
//            return ResponseBean.error("修改失败, 请重试", ResponseBean.ERROR_UNAVAILABLE);
//        }
//    }
//
//    /**
//     * 根据id查询对象
//     * @param id  实体ID
//     */
//    @RequestMapping(value="/taMetaImage/{id}",method= RequestMethod.GET)
//    @ApiOperation(value="详情", notes = "详情", httpMethod = "GET", response = ResponseBean.class)
//    public ResponseBean taMetaImageGet(@ApiParam("对象ID") @PathVariable Integer id) throws Exception{
//        return ResponseBean.success(iTaMetaImageService.getById(id));
//    }
}
