package com.shigongli.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.shigongli.constants.StatusConstant;
import com.shigongli.entity.TaMateTagGroup;
import com.shigongli.mapper.TaMateTagGroupMapper;
import com.shigongli.service.ITaMateTagGroupService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

/**
 * <p>
 * 素材标签组 服务实现类
 * </p>
 *
 * @author yansen
 * @since 2020-12-11
 */
@Service
public class TaMateTagGroupServiceImpl extends ServiceImpl<TaMateTagGroupMapper, TaMateTagGroup> implements ITaMateTagGroupService {

    @Override
    public TaMateTagGroup getByName(String name) {
        QueryWrapper<TaMateTagGroup> queryWrapper = new QueryWrapper<TaMateTagGroup>()
                .eq("name", name)
                .gt("status", StatusConstant.DELETE)
                .last("limit 1");

        return getOne(queryWrapper);
    }
}
