package com.shigongli.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.shigongli.constants.StatusConstant;
import com.shigongli.entity.TaShop;
import com.shigongli.mapper.TaShopMapper;
import com.shigongli.service.ITaShopService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

/**
 * <p>
 * 民宿店 服务实现类
 * </p>
 *
 * @author yansen
 * @since 2020-12-11
 */
@Service
public class TaShopServiceImpl extends ServiceImpl<TaShopMapper, TaShop> implements ITaShopService {

    @Override
    public TaShop getByName(String name) {
        QueryWrapper<TaShop> queryWrapper = new QueryWrapper<TaShop>()
                .eq("name", name)
                .gt("status", StatusConstant.DELETE)
                .last("limit 1");

        return getOne(queryWrapper);
    }
}
